;	HeXHub version 5.00 Copyright (C) 2006-2007 Albu Cristian
;
;	This program is free software; you can redistribute
;	it under the terms of the Open Software License version 2.1.
;
;	For more information send and e-mail to cristian.albu@gmail.com

WSA_FLAG_OVERLAPPED=1
OP_RECV=0
OP_SEND=1
OP_ACCEPT=2
OP_QOS=3
OP_MUSTSEND=4
SIO_GET_QOS=0c8000007h
SIO_SET_QOS=0c800000bh

OVERLAPPEDPLUS struct
	ovr		OVERLAPPED <>
	opcode		dd	?
	hSocket		dd	?
	hMem		dd	?
	retries		dd	?
	bfsize2		dd	?
	buffer2		dd	?
	written		dd	?
	bfidx2		dd	?
OVERLAPPEDPLUS ends

FLOWSPEC	struct
	TokenRate	dd	?
	TokenBucketSize	dd	?
	PeakBandwidth	dd	?
	Latency		dd	?
	DelayVariation	dd	?
	ServiceType	dd	?
	MaxSduSize	dd	?
	MinimumPolicedSize dd	?
FLOWSPEC	ends

QOS	struct
	sending		FLOWSPEC	<>
	receiving	FLOWSPEC	<>
	provider	dd		?,?
QOS	ends

IOCPdata	macro
	hIOCP		dd	?
	nodelay		dd	?
	numwaiting	dd	?
endm

IOCPdata1	macro
	ovr		OVERLAPPEDPLUS <>
	ovr_send	OVERLAPPEDPLUS <>
	last_op		db	?
endm

IOCPinit	macro
	mov	numwaiting,0
	mov	nodelay,1
endm

createsocket	macro
	.if hIOCP!=0
		invoke	WSASocket,AF_INET,SOCK_STREAM,IPPROTO_TCP,0,0,WSA_FLAG_OVERLAPPED
		push	eax
		.if IOCPf&1
			invoke	setsockopt,eax,SOL_SOCKET,SO_SNDBUF,addr so_sndb,2
			pop	eax
			push	eax
			movzx	ecx,word ptr so_sndb
			push	ecx
			invoke	getsockopt,eax,SOL_SOCKET,SO_SNDBUF,addr so_sndb,2
			pop	ecx
			.if cx!=so_sndb
				invoke	SetDlgItemInt,hDlg7,126,ecx,0
			.endif
		.endif
		pop	eax
	.else
		invoke	socket,AF_INET,SOCK_STREAM,IPPROTO_TCP
	.endif
	.if IOCPf&8
		push	eax
		mov	ecx,sizeof _qos
		mov	ebx,eax
		invoke	WSAIoctl,ebx,SIO_SET_QOS,addr _qos,ecx,0,0,addr bread,0,0
		.if eax==SOCKET_ERROR
			invoke	WSAGetLastError
			.if eax==WSAENOPROTOOPT
				and	IOCPf,8 xor -1
				invoke	CheckDlgButton,hDlg7,404,BST_UNCHECKED
				invoke	GetDlgItem,hDlg7,16
				invoke	EnableWindow,eax,0
			.endif
		.endif
		pop	eax
	.endif
endm


IOCPaccept	macro
	.if eax!=INVALID_SOCKET
		.if accepts>2999
			invoke	closesocket,eax
			jmp	_not_
		.endif
		mov	edx,offset accepted
		push	eax
		xor	eax,eax
		.while dword ptr[edx]!=0
			lea	edx,[edx+24]
			inc	eax
		.endw
		.if eax>=2999
			pop	eax
			invoke	closesocket,eax
			jmp	_not_
		.endif
		pop	eax
		mov	[edx+4],ecx
		mov	[edx+8],ebx
		mov	ecx,uMsg
		mov	[edx+12],ecx
		push	eax
		mov	eax,last_ipstr
		.if eax==0
			mov	ebx,ecx
			push	edx
			call	ipscached
			pop	edx
			mov	eax,edi
		.endif
		mov	[edx+16],eax
		pop	eax
		mov	dword ptr[edx+20],0
		mov	[edx],eax
		inc	accepts
	.endif
endm

IOCPthread	macro
assume	esi:ptr usrstruc

acceptThread	PROC	lParam:DWORD
	local	synratehub:DWORD,fread:DWORD,acc_delay:DWORD
	movzx	eax,fsyn1
	mov	synratehub,eax
	mov	acc_delay,20
	.while (hubstarted==1)||(accepts!=0)
		mov	ecx,accepts
		.if hDriver
			.if (ecx>200)&&(synratehub!=0)
				push	edi
				lea	edi,_ports
				.while edi
					assume	edi:ptr port_info
					movzx	eax,word ptr[edi].portnum
					push	eax
					mov	edx,esp
					lea	eax,fread
					FWcall	2220e4h,edx,4,0,0,eax,0
					pop	eax
					assume	edi:nothing
					mov	edi,[edi]
				.endw
				pop	edi
				mov	synratehub,0
			.elseif (ecx>50)&&(synratehub!=1)
				xor	ecx,ecx
				assume	edx:ptr s_record
				mov	edx,s_private
				xor	eax,eax
				.while ([edx].s_opcode!=0)&&(edx!=s_lastpriv)&&(edx!=0)
					inc	ecx
					add	eax,[edx].s_used
					mov	edx,[edx].s_next
				.endw
				assume	edx:nothing
				push	edi
				lea	edi,_ports
				.while edi
					assume	edi:ptr port_info
					.if ecx>100
						xor	eax,eax
					.else
						mov	eax,10000h
					.endif
					mov	ax,word ptr[edi].portnum
					push	eax
					mov	edx,esp
					lea	eax,fread
					push	ecx
					FWcall	2220e4h,edx,4,0,0,eax,0
					pop	ecx
					pop	eax
					assume	edi:nothing
					mov	edi,[edi]
				.endw
				pop	edi
				.if ecx>100
					mov	synratehub,0
				.else
					mov	synratehub,1
				.endif
			.elseif (ecx<20)
				movzx	eax,fsyn1
				.if eax!=synratehub
					mov	synratehub,eax
					push	edi
					lea	edi,_ports
					.while edi
						assume	edi:ptr port_info
						mov	eax,dword ptr fsyn1-2
						mov	ax,word ptr[edi].portnum
						push	eax
						mov	edx,esp
						lea	eax,fread
						FWcall	2220e4h,edx,4,0,0,eax,0
						pop	eax
						assume	edi:nothing
						mov	edi,[edi]
					.endw
					pop	edi
				.endif
			.else
				push	edi
				lea	edi,_ports
				.while edi
					assume	edi:ptr port_info
					mov	eax,10000h
					mov	ax,word ptr[edi].portnum
					push	eax
					mov	edx,esp
					lea	eax,fread
					FWcall	2220e4h,edx,4,0,0,eax,0
					pop	eax
					assume	edi:nothing
					mov	edi,[edi]
				.endw
				pop	edi
				mov	synratehub,1
			.endif
		.endif
		mov	ecx,accepts
		mov	edx,offset accepted
		.while ecx!=0
			.while dword ptr[edx]==0
				lea	edx,[edx+24]
			.endw
			.if hubstarted==0
				push	ecx
				push	edx
				invoke	closesocket,dword ptr[edx]
				pop	edx
				pop	ecx
				mov	dword ptr[edx],0
				dec	accepts
				jmp	_not_b
			.endif
			push	ecx
			push	edx
			mov	eax,[edx]
			mov	ebx,[edx+8]
			mov	ecx,[edx+4]
			mov	edx,[edx+16]
			assume	edx:ptr ip_info
			.if [edx].flagextra&1
				mov	dl,[edx].country
			.else
				push	eax
				push	edx
				mov	eax,ecx
				call	tzarainfo
				mov	al,dl
				pop	edx
				or	[edx].flagextra,1
				mov	[edx].country,al
				mov	dl,al
				pop	eax
			.endif
			assume	edx:nothing
			movzx	edx,dl
			call	ispchk
			pop	edx
			push	edx
			jnc	_acc_a
			invoke	closesocket,dword ptr[edx]
			jmp	_not_a
_acc_a:			.if (proxyflag&1)&&(proxyflag&2)
				mov	ecx,[edx+16]
				assume	ecx:ptr ip_info
				mov	eax,[ecx].lastip
				.if (al==127)||(ax==168*256+192)||(al==10)||((al==172)&&(ah>=16)&&(ah<=31))		;rfc1918
					jmp	notprx
				.endif
				.if (dword ptr[edx+20]==0)&&([ecx].waiting&8)
					.if ([ecx].waiting&16)
						pop	edx
						push	edx
						push	edx
						push	ecx
						mov	ecx,dword ptr[ecx].lastip
						plugban0	8,1
						assume	esi:ptr usrstruc
						pop	ecx
						pop	edx
						.if eax
							invoke	closesocket,dword ptr[edx]
							jmp	_not_a
						.endif
						mov	eax,[edx]
					.endif
					assume	ecx:nothing
				.elseif (edx<offset critical)&&(!(fhflag&1))
					.if dword ptr[edx+20]==0
						mov	esi,offset pthreads
						mov	ecx,proxythreads
						.while ecx
							assume	esi:ptr proxy_info
							.if [esi].state==0
								inc	[esi].state
								.if [esi].state==1
									or	word ptr[edx+20],100h
									move	[esi].check_ip,dword ptr[edx+4]
									mov	[esi].ptr_ip,edx
									mov	[esi].hSocket,eax
									mov	[esi].ipstate,0
									inc	[esi].state
									.break
								.else
									dec	[esi].state
								.endif
							.endif
							assume	esi:ptr usrstruc
							lea	esi,[esi+sizeof proxy_info]
							dec	ecx
						.endw
						pop	edx
						pop	ecx
						jmp	_not_b
					.elseif byte ptr[edx+20]&16
						mov	ecx,[edx+16]
						assume	ecx:ptr ip_info
						or	[ecx].waiting,8+16
						push	edx
						push	ecx
						mov	ecx,dword ptr[ecx].lastip
						plugban0	8,1
						assume	esi:ptr usrstruc
						assume	ecx:nothing
						pop	ecx
						pop	edx
						.if eax
							invoke	closesocket,dword ptr[edx]
							jmp	_not_a
						.endif
					.elseif byte ptr[edx+20]&8
						mov	ecx,[edx+16]
						assume	ecx:ptr ip_info
						or	[ecx].waiting,8
						assume	ecx:nothing
					.else
						pop	edx
						pop	ecx
						jmp	_not_b
					.endif
				.endif
			.endif
notprx:			mov	edi,offset threads+8
			.while (dword ptr[edi]!=0)&&(dword ptr[edi]!=-1)
				scasd
			.endw
			.if dword ptr[edi]!=-1
				invoke	GlobalAlloc,GPTR,sizeof usrstruc
				mov	esi,eax
				call	initesi
				pop	edx
				push	edx
				move	[esi].hSocket,dword ptr[edx]
				move	[esi]._ip,dword ptr[edx+4]
				move	[esi]._port,dword ptr[edx+8]
				mov	eax,tcount
				mov	[esi].conntime,eax
				mov	[esi].proftime,eax
				s_userinit
				mov	[edi],esi
				mov	[edi-sizeof threadz],esi
			.else
				mov	esi,[edi-sizeof threadz]
				call	initesi
				pop	edx
				push	edx
				move	[esi].hSocket,dword ptr[edx]
				move	[esi]._ip,dword ptr[edx+4]
				move	[esi]._port,dword ptr[edx+8]
				mov	eax,tcount
				mov	[esi].conntime,eax
				mov	[esi].proftime,eax
				s_userinit
				mov	[edi],esi
			.endif
			mov	[esi].hMem1,0
			pop	edx
			push	edx
			push	edi
			mov	edi,[edx+16]
			mov	[esi].ipptr,edi
			mov	eax,[edx+12]
			sub	eax,WM_USER+10
			mov	[esi].portidx,al
			mov	eax,[edx+12]
			push	edx
			mov	edx,_ports
			.while edx
				assume	edx:ptr port_info
				.if eax==[edx].wmsocket
					mov	ax,word ptr[edx].portnum
					mov	[esi].connport,ax
					.break
				.endif
				assume	edx:nothing
				mov	edx,[edx]
			.endw
			pop	edx
			langset
			.if IOCPf&2
				invoke	setsockopt,[esi].hSocket,IPPROTO_TCP,TCP_NODELAY,addr nodelay,1
			.endif
			.if IOCPf&1
				invoke	setsockopt,[esi].hSocket,SOL_SOCKET,SO_SNDBUF,addr so_sndb,2
			.endif
			pop	edi

			.if hIOCP!=0
				mov	[esi].ovr.hMem,esi
				mov	eax,[esi].hSocket
				mov	[esi].ovr.hSocket,eax
				mov	[esi].ovr.opcode,OP_ACCEPT
				invoke	CreateIoCompletionPort,[esi].hSocket,hIOCP,0,0
				.if eax
					invoke	PostQueuedCompletionStatus,hIOCP,0,0,addr [esi].ovr
				.else
					invoke	closesocket,[esi].hSocket
					mov	ebx,offset threads
					.while (dword ptr[ebx]!=0)&&(dword ptr[ebx]!=esi)
						lea	ebx,[ebx+4]
					.endw
					.if dword ptr[ebx]==esi
						mov	dword ptr[ebx],-1
					.endif
				.endif
			.else
				push	esi
				invoke	CreateThread,0,0,addr Thread2,edi,0,addr thrid
				pop	esi
				mov	[esi].hThread,eax
			.endif
_not_a:			pop	edx
			pop	ecx
			mov	dword ptr[edx],0
			dec	accepts
			.if accepts==0
				mov	edx,s_buffers
				xor	ecx,ecx
				assume	edx:ptr s_record
				.while ([edx].s_opcode!=0)&&(edx!=s_lastbuf)&&(edx!=0)&&(ecx<51)
					inc	ecx
					mov	edx,[edx].s_next
				.endw
				.if (ecx>50)&&(acc_delay<150)
					add	acc_delay,10
				.elseif (ecx<10)&&(acc_delay>5)
					sub	acc_delay,5
				.endif
			.endif
			invoke	Sleep,acc_delay
			assume	edx:nothing
			jmp	_accepted
			.break
_not_b:			lea	edx,[edx+24]
			dec	ecx
		.endw
		invoke	Sleep,100
_accepted:
	.endw
	invoke	ExitThread,0
	ret
acceptThread	ENDP

asend	PROC	msg:DWORD,szmsg:DWORD
	local	sendretry:DWORD
	.if ([esi].outDisable&1)
		.if [esi].lpDis
			push	esi
			push	edi
			push	ebx
			push	ecx
			push	szmsg
			push	msg
			call	[esi].lpDis
			pop	ecx
			pop	ebx
			pop	edi
			pop	esi
			.if eax==0
				ret
			.endif
		.else
			ret
		.endif
	.endif
	.if (s_started)
		push	edi
		push	ecx
		push	ebx
		mov	edi,msg
		mov	ecx,szmsg
		call	s_add_private
		.if (s_started==2)
			call	post_IOCP
		.endif
		pop	ebx
		pop	ecx
		pop	edi
		ret
	.endif
		mov	sendretry,0
		.if ([esi].pm_is_spam>1)
			xor	eax,eax
			ret
		.endif
		push	ebx
		xor	eax,eax
		.while eax<szmsg
			lea	ecx,[esi].fdset
			assume	ecx:ptr fd_set
			mov	eax,[esi].hSocket
			mov	[ecx].fd_count,1
			mov	[ecx].fd_array,eax
			assume	ecx:nothing
			.if timeout1==0
				xor	edx,edx
			.else
				mov	edx,offset timewait
			.endif
			invoke	select,10h,0,ecx,0,edx
			.if (eax==SOCKET_ERROR)||(eax==0)
				mov	[esi].pm_is_spam,2
				mov	eax,SOCKET_ERROR
				.break
			.endif
			mov	eax,szmsg
			.if send_buff!=0
				.if eax>send_buff
					mov	eax,send_buff
				.endif
			.endif
			add	bps_s,eax
			invoke	send,[esi].hSocket,msg,eax,0
			.if eax==SOCKET_ERROR
				invoke	WSAGetLastError
				.if (eax==WSAENOBUFS)&&(send_buff>256)&&(send_buff!=0)&&(IOCPf&64)
					sub	send_buff,64
					invoke	SetDlgItemInt,hDlg7,109,send_buff,0
					mov	eax,tcount
					sub	eax,last_n
					.if eax>7fffffffh
						neg	eax
					.endif
					.if eax>60
						mov	eax,tcount
						mov	last_n,eax
						mov	eax,100
						.if s_to.cmdflag&32
							mov	ax,word ptr s_to.cmdparam2+2
						.endif
						.if op_messages<ax
							movzx	ecx,op_messages
							shl	ecx,6
							lea	edi,[ecx+offset op_str]
							scasd
							mov	eax,3
							stosd
							mov	eax,tcount
							stosd
							inc	op_messages
						.endif
					.endif
					xor	eax,eax
				.elseif eax==WSAEINPROGRESS
				.elseif eax==WSAEWOULDBLOCK
				.elseif eax!=WSAENOBUFS
					mov	eax,SOCKET_ERROR
					mov	[esi].pm_is_spam,2
					.break
				.endif
				xor	eax,eax
			.endif
			sub	szmsg,eax
			add	msg,eax
			.if eax==0
				inc	sendretry
				mov	eax,sendretry
				.if eax>=SendRetries
					mov	eax,SOCKET_ERROR
					mov	[esi].pm_is_spam,2
					.break
				.endif
				invoke	Sleep,10
			.endif
			xor	eax,eax
		.endw
		pop	ebx
		ret
	ret
asend	ENDP

post_IOCP:
	or	[esi].waiting,128
	.if [esi].waiting&32
		ret
	.endif
	or	[esi].waiting,32
	mov	[esi].last_op,0
	assume	edi:ptr OVERLAPPEDPLUS
	push	ebx
	push	edi
	lea	edi,[esi].ovr_send.ovr
	xor	eax,eax
	stosd
	stosd
	stosd
	stosd
	stosd
	lea	edi,[esi].ovr_send
	mov	[edi].opcode,OP_MUSTSEND
	push	[esi].hSocket
	pop	[edi].hSocket
	mov	[edi].hMem,esi
	mov	[edi].retries,0
	invoke	PostQueuedCompletionStatus,hIOCP,0,1,addr [edi].ovr
	pop	edi
	pop	ebx
	assume	edi:nothing
	ret

assume	edx:ptr s_record
broadcast:
	.if hIOCP==0
		push	esi
		mov	edx,offset threads+8
		.while dword ptr[edx]!=0
			mov	esi,dword ptr [edx]
			.if esi!=-1
				.if ([esi].pm_is_spam<2)
					push	edx
					push	ecx
					.if ([esi].loggedin==1)&&([esi].hSocket!=0)
						invoke	asend,edi,ecx
					.elseif ([esi].hSocket!=0)&&([esi].hThread!=0)
						mov	eax,tcount
						sub	eax,[esi].conntime
						.if (s_validatenick.cmdflag&1)&&(eax>=s_validatenick.cmdparam1)
							onBadSettings	30
							.if eax
								.if (!([esi].outDisable&1))&&(!([esi].outDisable&4))
									mov	eax,tcount
									mov	[esi].conntime,eax
									mov	edi,[esi].hMem1
									xor	ecx,ecx
									call	get_rbstr
									sendbuffer1
								.endif
								call	disconn
							.endif
						.endif
					.endif
					pop	ecx
					pop	edx
				.endif
			.endif
			lea	edx,[edx+4]
		.endw
		pop	esi
		ret
	.else
		push	esi
		lea	esi,rbstruc
		call	s_add_bc
		pop	esi
		.if (s_started==1)
			ret
		.endif
	.endif

_bcast:
	invoke	EnterCriticalSection,addr s_critical
	xor	ecx,ecx
	inc	ecx
	mov	edx,s_buffers
	.while edx!=0
		mov	[edx].s_index,ecx
		mov	edx,[edx].s_next
		inc	ecx
	.endw
	mov	s_min,-1

	mov	eax,esi
	mov	edx,offset threads+8
	push	esi
	.while dword ptr[edx]!=0
		mov	esi,dword ptr [edx]
		.if esi!=-1
			push	edx
			push	ecx
			.if ([esi].loggedin==1)&&([esi].hSocket!=0)&&([esi].pm_is_spam<2)
				or	[esi].waiting,128
				.if (!([esi].waiting&32))&&(!([esi].outDisable&4))&&(!([esi].outDisable&1))
					or	[esi].waiting,32
					mov	[esi].last_op,0
					assume	edi:ptr OVERLAPPEDPLUS
					push	ebx
					push	edi
					lea	edi,[esi].ovr_send.ovr
					xor	eax,eax
					stosd
					stosd
					stosd
					stosd
					stosd
					lea	edi,[esi].ovr_send
					mov	[edi].opcode,OP_MUSTSEND
					push	[esi].hSocket
					pop	[edi].hSocket
					mov	[edi].hMem,esi
					mov	[edi].retries,0
					invoke	PostQueuedCompletionStatus,hIOCP,0,1,addr [edi].ovr
					pop	edi
					pop	ebx
				.endif
				mov	edx,[esi].s__bufno
				mov	eax,[edx].s_index
				.if eax<s_min
					mov	s_min,eax
				.endif
			.elseif ([esi].hSocket!=0)&&([esi].loggedin==0)
				mov	eax,tcount
				sub	eax,[esi].conntime
				.if eax>7fffffffh
					neg	eax
				.endif
				.if (s_validatenick.cmdflag&1)&&(eax>=s_validatenick.cmdparam1)
					onBadSettings	30
					.if eax
						mov	eax,tcount
						mov	[esi].conntime,eax
						onError	[esi].sessionId,1
						invoke	asend,addr _timeout,sizeof _timeout
						call	disconn			;
					.endif
				.endif
			.endif
			.if timeout1&&([esi].waiting&32)&&([esi].last_op!=0)
				mov	eax,tcount
				sub	eax,[esi].s__lastsendtime
				.if eax>7fffffffh
					neg	eax
				.endif
				.if eax>timeout1
					onError	[esi].sessionId,2
					mov	eax,tcount
					mov	[esi].s__lastsendtime,eax
					call	closeconn
				.endif
			.endif
			pop	ecx
			pop	edx
		.endif
		lea	edx,[edx+4]
	.endw
_delbc:	pop	esi
	.if s_min!=-1
		.while s_min>1
			mov	edx,s_buffers
			mov	[edx].s_opcode,0
			mov	[edx].s_pending,0
			assume	ecx:ptr s_record
			mov	eax,[edx].s_next
			mov	ecx,[edx].s_prev
			mov	s_buffers,eax
			assume	eax:ptr s_record
			mov	[eax].s_prev,ecx
			assume	eax:nothing
			mov	ecx,s_lastbuf
			mov	[ecx].s_next,edx
			mov	[edx].s_prev,ecx
			mov	[edx].s_next,0
			mov	s_lastbuf,edx
			assume	ecx:nothing
			dec	s_min
		.endw
	.endif
	invoke	LeaveCriticalSection,addr s_critical
	ret



;edi=src
sendtoall:
	mov	ecx,edi
	mov	edi,[esi].hMem1
	.if edi==0
		ret
	.endif
	sub	ecx,edi
	call	wrmain
	.if eax==0
		ret
	.endif

publicmsg:
	.if s_started==0
		push	ecx
		invoke	asend,edi,ecx
		pop	ecx
_public2:	mov	eax,esi
		mov	edx,offset threads+8
		push	esi
		.while dword ptr[edx]!=0
			mov	esi,dword ptr [edx]
			.if esi!=-1
				push	edx
				push	ecx
				push	eax
				mov	dl,1
				.if ([esi].outDisable&1)
					.if [esi].lpDis
						push	eax
						push	esi
						push	edi
						push	ebx
						push	ecx
						push	ecx
						push	edi
						call	[esi].lpDis
						pop	ecx
						pop	ebx
						pop	edi
						pop	esi
						.if eax!=0
							mov	dl,1
						.else
							mov	dl,0
						.endif
						pop	eax
					.else
						mov	dl,0
					.endif
				.endif
				.if (([esi].loggedin==1)&&([esi].rights&_0_chat2))&&(eax!=esi)&&(dl==1)&&(!([esi].outDisable&4))
					invoke	asend,edi,ecx
				.elseif ([esi].hSocket!=0)&&([esi].hThread!=0)&&([esi].loggedin==0)
					mov	eax,tcount
					sub	eax,[esi].conntime
					.if (s_validatenick.cmdflag&1)&&(eax>=s_validatenick.cmdparam1)
						onBadSettings	30
						.if eax
							mov	eax,tcount
							mov	[esi].conntime,eax
							invoke	asend,addr _timeout,sizeof _timeout
							call	disconn
						.endif
					.endif
				.endif
				pop	eax
				pop	ecx
				pop	edx
			.endif
			lea	edx,[edx+4]
		.endw
		pop	esi
		ret
	.else
		push	ecx
		call	s_add_private
		pop	ecx
		call	s_add_bc
		.if (s_started==1)
			ret
		.endif
		jmp	_bcast
	.endif

_public1:.if s_started==0
		jmp	_public2
	.endif
	call	s_add_bc
	.if s_started==1
		ret
	.endif
_bcex:
	invoke	EnterCriticalSection,addr s_critical
	xor	ecx,ecx
	inc	ecx
	mov	edx,s_buffers
	.while edx!=0
		mov	[edx].s_index,ecx
		mov	edx,[edx].s_next
		inc	ecx
	.endw
	mov	s_min,-1

	mov	eax,esi
	mov	edx,offset threads+8
	push	esi
	.while dword ptr[edx]!=0
		mov	esi,dword ptr [edx]
		.if esi!=-1
			push	edx
			push	ecx
			push	eax
			.if ([esi].loggedin==1)&&([esi].hSocket!=0)&&([esi].pm_is_spam<2)
				.if (eax!=esi)
					or	[esi].waiting,128
					.if (!([esi].waiting&32))&&(!([esi].outDisable&4))&&(!([esi].outDisable&1))
						or	[esi].waiting,32
						mov	[esi].last_op,0
						assume	edi:ptr OVERLAPPEDPLUS
						push	ebx
						push	edi
						lea	edi,[esi].ovr_send.ovr
						xor	eax,eax
						stosd
						stosd
						stosd
						stosd
						stosd
						lea	edi,[esi].ovr_send
						mov	[edi].opcode,OP_MUSTSEND
						push	[esi].hSocket
						pop	[edi].hSocket
						mov	[edi].hMem,esi
						mov	[edi].retries,0
						invoke	PostQueuedCompletionStatus,hIOCP,0,1,addr [edi].ovr
						pop	edi
						pop	ebx
					.endif
				.endif
				mov	edx,[esi].s__bufno
				mov	eax,[edx].s_index
				.if eax<s_min
					mov	s_min,eax
				.endif
			.elseif ([esi].hSocket!=0)&&([esi].loggedin==0)
				mov	eax,tcount
				sub	eax,[esi].conntime
				.if eax>7fffffffh
					neg	eax
				.endif
				.if (s_validatenick.cmdflag&1)&&(eax>=s_validatenick.cmdparam1)
					onBadSettings	30
					.if eax
						mov	eax,tcount
						mov	[esi].conntime,eax
						onError	[esi].sessionId,1
						invoke	asend,addr _timeout,sizeof _timeout
						call	disconn			;
					.endif
				.endif
			.endif
			.if timeout1&&([esi].waiting&32)&&([esi].last_op!=0)
				mov	eax,tcount
				sub	eax,[esi].s__lastsendtime
				.if eax>7fffffffh
					neg	eax
				.endif
				.if eax>timeout1
					onError	[esi].sessionId,2
					mov	eax,tcount
					mov	[esi].s__lastsendtime,eax
					call	closeconn
				.endif
			.endif
			pop	eax
			pop	ecx
			pop	edx
		.endif
		lea	edx,[edx+4]
	.endw
	jmp	_delbc
assume	ebx:nothing


;esi
;setQoS:	.if IOCPf&8
;		.if hIOCP!=0
			push	edi
			lea	edi,[esi].ovr.ovr
			mov	ecx,5
			xor	eax,eax
			rep	stosd
			pop	edi
			mov	[esi].ovr.opcode,OP_QOS
			mov	ecx,sizeof _qos
			invoke	WSAIoctl,[esi].hSocket,SIO_SET_QOS,addr _qos,ecx,addr _qos,ecx,addr [esi+40].buffer_tmp,addr [esi].ovr.ovr,0
;		.else
;			mov	ecx,sizeof _qos
;			invoke	WSAIoctl,[esi].hSocket,SIO_SET_QOS,addr _qos,ecx,addr _qos,ecx,addr [esi+40].buffer_tmp,0,0
;		.endif

		.if eax==SOCKET_ERROR
			invoke	WSAGetLastError
			.if eax==WSAENOPROTOOPT
				and	IOCPf,8 xor -1
				invoke	CheckDlgButton,hDlg7,404,BST_UNCHECKED
				invoke	GetDlgItem,hDlg7,16
				invoke	EnableWindow,eax,0
			.endif
		.endif
;	.endif
	ret

workerThread	PROC	lParam:DWORD
	local	wtransfered:DWORD
	local	wcontext:DWORD
	local	wlpovr:DWORD
	local	tmpusr:DWORD
	inc	activethreads
	inc	busythreads
	.while 1
		mov	wlpovr,0
		assume	edi:ptr OVERLAPPEDPLUS
		assume	esi:ptr usrstruc
		.while 1
			dec	busythreads
			invoke	GetQueuedCompletionStatus,hIOCP,addr wtransfered,addr wcontext,addr wlpovr,INFINITE
			inc	busythreads
			.if wcontext==-1
				dec	activethreads
				dec	busythreads
				invoke	ExitThread,0
				ret
			.endif
			.if (eax!=0)&&(dword ptr wlpovr!=0)
				mov	edi,wlpovr
				mov	eax,[edi].opcode
				mov	ecx,[edi].hSocket
				mov	esi,dword ptr [edi].hMem
				.if (esi!=0)
					mov	ecx,wtransfered
					.if eax==OP_SEND
						add	bps_s,ecx
					.elseif eax==OP_RECV
						add	bps_r,ecx
					.endif
					.break
				.endif
			.elseif wlpovr!=0
				mov	edi,wlpovr
				mov	eax,[edi].opcode
				mov	esi,dword ptr [edi].hMem
				mov	ecx,[edi].hSocket
				.if (esi!=0)
					.if eax==OP_RECV
						onError	[esi].sessionId,4
						jmp	_r01c
					.elseif eax==OP_SEND
						inc	[edi].retries
						mov	eax,[edi].retries
						.if (SendRetries!=0)&&(eax>=SendRetries)
							call	disconn
							onError	[esi].sessionId,8
						.else	;if [esi].locked==0
							mov	eax,OP_SEND
							mov	wtransfered,0
							.break
						.endif
					.else
						jmp	_r01c
					.endif
				.endif
				onError	0,16
			.endif
		.endw
		.if hubstarted==0
			dec	activethreads
			dec	busythreads
			invoke	ExitThread,0
			ret
		.endif
		.if esi!=0
		.if ([esi].pm_is_spam>1)
			.if (!([esi].myinfwait1&64))
				or	[esi].myinfwait1,64
				onError	[esi].sessionId,32
			.endif
_r01c:			.if eax==OP_SEND
_r01c_:				
			.endif
			.if [esi].hSocket
				call	closed
			.endif
_r03c:
		.else
			.if eax==OP_ACCEPT
				.if [esi].locked==1
					mov	eax,maxthreadz
					shr	eax,1
					.if eax>=numwaiting
						inc	numwaiting
						mov	ecx,2000
						.while ecx
							push	ecx
							invoke	Sleep,20
							pop	ecx
							dec	ecx
							.break .if ([esi].locked==0)
							.if ([esi].hSocket==0)||([esi].pm_is_spam>1)
								jmp	aecv_errs
							.endif
						.endw
						dec	numwaiting
						.if [esi].locked==0
							jmp	_andreent
						.endif
					.endif
aecv_errs:				onError	[esi].sessionId,128
					call	closed
					jmp	_r03c
				.endif
_andreent:			mov	[esi].locked,1
	;			push	[esi].s__bufno
;				call	user_init

				mov	[esi].locked,1
				getsendbuff
				.if edi==0
					call	no_mem
					jmp	_r01c
				.endif
				call	u_init
				freesendbuff
				.if [esi].pm_is_spam>1
					xor	eax,eax
					jmp	_r01c
				.endif
				lea	edi,[esi].ovr
				push	edi
				xor	eax,eax
				stosd
				stosd
				stosd
				stosd
				stosd
				pop	edi
				mov	[esi].ovr.opcode,OP_RECV
				lea	eax,[esi].buffer_in
				mov	[esi].ovr.buffer2,eax
				mov	[esi].ovr.bfidx2,0
				mov	[esi].ovr.retries,0
				or	[esi].waiting,1h
				mov	eax,[esi].hSocket
				mov	[esi].ovr.hSocket,eax
				mov	[esi].ovr.hMem,esi
	;			pop	eax
	;			.if s_started
	;				assume	eax:ptr s_record
	;				.while ([esi].s__bufno==eax)&&([eax].s_pending!=0)
	;					push	eax
	;					invoke	Sleep,10
	;					pop	eax
	;				.endw
	;				assume	eax:nothing
	;			.endif
				.if (s_started==0)||([esi].pm_is_spam<2)
		;			xor	eax,eax
		;			.while eax==0
		;				invoke	PostQueuedCompletionStatus,hIOCP,-1,0,addr [esi].ovr
		;				.break .if eax
		;				invoke	Sleep,10
		;				xor	eax,eax
		;			.endw
					invoke	ReadFile,[esi].hSocket,[esi].ovr.buffer2,BUFMAX-30,addr [esi].ovr.written,addr [esi].ovr
					.if (eax==0)||(eax==-1)
						invoke	WSAGetLastError
						.if eax!=ERROR_IO_PENDING
							xor	eax,eax
							jmp _r01c
						.endif
					.endif
				.endif
				mov	[esi].locked,0
			.elseif eax==OP_RECV
				.if [esi].locked==1
					mov	eax,maxthreadz
					shr	eax,1
					.if eax>=numwaiting
						inc	numwaiting
						mov	ecx,2000
						.while ecx
							push	ecx
							invoke	Sleep,20
							pop	ecx
							dec	ecx
							.break .if ([esi].locked==0)
							.if ([esi].hSocket==0)||([esi].pm_is_spam>1)
								jmp	recv_errs
							.endif
						.endw
						dec	numwaiting
						.if [esi].locked==0
							jmp	_endreent
						.endif
					.endif
recv_errs:				onError	[esi].sessionId,128
					call	closed
					jmp	_r03c
				.endif
_endreent:			mov	[esi].locked,1
				mov	eax,wtransfered
				.if eax==0
					xor	eax,eax
					jmp	_r01c
				.elseif eax==-1
					mov	[esi].ovr.bfidx2,0
					mov	[esi].ovr.bfsize2,0
					lea	eax,[esi].buffer_in
					mov	[esi].ovr.buffer2,eax
					mov	[esi].ovr.opcode,OP_RECV
					jmp	_r11b
				.endif
				and	[esi].waiting,0feh
				mov	edi,[esi].ovr.buffer2
				.if edi==0
					lea	eax,[esi].buffer_in
					mov	edi,eax
					mov	[esi].ovr.buffer2,eax
					mov	eax,wtransfered
				.endif
				add	edi,[esi].ovr.bfidx2
				OnDataFromUser
				mov	word ptr[edi+eax],7c00h
				add	[esi].ovr.bfidx2,eax
				mov	edi,[esi].ovr.buffer2
				.if eax
					.if [esi].lpFunc
						push	esi
						mov	eax,[esi].ovr.bfidx2
						mov	[esi].ovr.bfsize2,eax
						mov	[esi].ovr.bfidx2,0
						push	eax
						push	[esi].ovr.buffer2
						push	[esi].sessionId
						call	[esi].lpFunc
						pop	esi
						mov	[esi].ovr.bfsize2,0
					.else
						.if (byte ptr[edi]=='$')||(byte ptr[edi]=='<')||(byte ptr[edi]=='|')
							mov	ecx,[esi].ovr.bfidx2
							mov	al,'|'
							repne	scasb
							jnz	_r11b
						.endif
						mov	eax,[esi].ovr.bfidx2
						mov	[esi].ovr.bfsize2,eax
						mov	[esi].ovr.bfidx2,0
						.if ([esi].pm_is_spam<2)&&(!([esi].waiting&2))
							getsendbuff
							.if edi==0
								call	no_mem
								jmp	_r01c
							.endif
							s_enter
							call	cmdexec
							s_leave
							freesendbuff
							.if [esi].http_tmp
								and	[esi].waiting,8 xor -1
								mov	eax,[esi].ovr.bfsize2
								add	[esi].ovr.bfidx2,eax
								mov	[esi].ovr.bfsize2,0
								.continue .if eax>=BUFMAX1-4096
								jmp	_r11b
							.endif
						.endif
					.endif
				.else
					mov	[esi].ovr.bfsize2,0
				.endif
				.if [esi].pm_is_spam>1
					mov	[esi].ovr.bfidx2,0
					mov	[esi].ovr.bfsize2,0
					xor	eax,eax
					jmp	_r01c
				.endif
				and	[esi].waiting,8 xor -1
				.if [esi].ovr.bfsize2!=0
					push	esi
					push	edi
					mov	ecx,[esi].ovr.bfsize2
					mov	edi,[esi].ovr.buffer2
					mov	esi,[esi].ovr.bfidx2
					add	esi,edi
					rep	movsb
					pop	edi
					pop	esi
				.else
					lea	eax,[esi].buffer_in
					.if (eax!=[esi].ovr.buffer2)
						mov	eax,[esi].ovr.buffer2
						.if eax
							dec	dword ptr[eax-4]
						.endif
						lea	eax,[esi].buffer_in
						mov	[esi].ovr.buffer2,eax
					.endif
				.endif
				mov	eax,[esi].ovr.bfsize2
				mov	[esi].ovr.bfidx2,eax
				mov	[esi].ovr.bfsize2,0
_r11b:				lea	eax,[esi].buffer_in
				mov	ecx,BUFMAX1-(BUFMAX1/4)
				.if eax==[esi].ovr.buffer2
					mov	ecx,BUFMAX1-(BUFMAX1/4)
					mov	eax,[esi].ovr.bfidx2
					add	eax,ecx
					.if eax>(BUFMAX-4)
						push	esi
						mov	ecx,[esi].ovr.bfidx2
						mov	esi,[esi].ovr.buffer2
						call	sndbuff1
						pop	esi
						mov	[esi].ovr.buffer2,edi
						mov	ecx,BUFMAX1-(BUFMAX1/4)
					.endif
				.endif
				.if ([esi].pm_is_spam<2)&&(!([esi].waiting&2))
					mov	eax,[esi].hSocket
					mov	[esi].ovr.hSocket,eax
					push	edi
					lea	edi,[esi].ovr
					xor	eax,eax
					stosd
					stosd
					stosd
					stosd
					stosd
					pop	edi
					mov	eax,BUFMAX1-2048
					sub	eax,[esi].ovr.bfidx2
					.if ecx>eax
						mov	ecx,eax
					.endif
					mov	eax,[esi].ovr.buffer2
					add	eax,[esi].ovr.bfidx2
					.if [esi].ovr.bfidx2>=(BUFMAX1-2048)
						xor	eax,eax
						jmp	_r01c
					.endif
					mov	[esi].ovr.retries,0
					mov	[esi].ovr.hMem,esi
					or	[esi].waiting,1
					mov	edx,eax
					invoke	ReadFile,[esi].hSocket,edx,ecx,addr [esi].ovr.written,addr [esi].ovr
_r02c_:					.if (eax==0)||(eax==-1)
						invoke	WSAGetLastError
						.if eax!=ERROR_IO_PENDING
							xor	eax,eax
							jmp	_r01c
						.endif
					.endif
				.else
					xor	eax,eax
					jmp	_r01c
				.endif
			.elseif eax==OP_MUSTSEND
				and	[esi].waiting,128 xor -1
				jmp	_scom_
			.elseif (eax==OP_SEND)&&(IOCPf&128)
_send:				and	[esi].waiting,128 xor -1
				mov	ecx,wtransfered
				mov	eax,[edi].bfidx2
				add	eax,ecx
				.if IOCPf&32
					.if ([esi].pm_is_spam==2)
						and	[esi].waiting,32 xor -1
						jmp	_r01c
					.elseif (!([esi].waiting&32))
						jmp	_r03c
					.endif
					assume	edx:ptr s_record
					.if ([esi].last_op==2)&&(!([esi].waiting&2))
						mov	edx,[esi].s__bufno
						.if edx==0
							and	[esi].waiting,32 xor -1
							jmp	_r03c
						.endif
						mov	eax,[edi].bfidx2
						add	[esi].s__idx,eax
						.if ([edx].s_opcode>2)
							push	edx
							invoke	EnterCriticalSection,addr s_critical
							pop	edx
							mov	ecx,wtransfered
							mov	eax,ecx
							add	ecx,[esi].s__idx
							.if ecx>=[edx].s_used
								mov	edx,[edx].s_next
								mov	[esi].s__bufno,edx
								mov	[esi].s__idx,0
								mov	[esi].s__retry,0
								mov	s_lasterr,1
							.elseif ecx>[edx].s_used
								int 3
							.else
								add	[esi].s__idx,eax
								mov	[esi].s__retry,0
							.endif
							invoke	LeaveCriticalSection,addr s_critical
						.else
							mov	ecx,wtransfered
							mov	eax,ecx
							add	ecx,[esi].s__idx
							push	[edx].s_used
							.if ecx>=[edx].s_used
								push	edx
								invoke	EnterCriticalSection,addr s_critical
								pop	edx
								pop	eax
								.if eax!=[edx].s_used
									mov	eax,[edx].s_used
									mov	[esi].s__idx,eax
									invoke	LeaveCriticalSection,addr s_critical
									and	[esi].waiting,32 xor -1
									jmp	_r03c
								.endif
								push	eax
								.if [edx].s_opcode!=0
									mov	[edx].s_pending,-2
									mov	edx,[edx].s_next
									mov	[esi].s__bufno,edx
								.endif
								mov	[esi].s__idx,0
								mov	[esi].s__retry,0
								invoke	LeaveCriticalSection,addr s_critical
							.elseif ecx>[edx].s_used
								int 3
							.else
								add	[esi].s__idx,eax
								mov	[esi].s__retry,0
							.endif
							pop	eax
						.endif
					.elseif [esi].s__bufpm!=0
						invoke	EnterCriticalSection,addr s_critical
						mov	eax,[edi].bfidx2
						add	[esi].s__idxpm,eax
						mov	eax,wtransfered
						mov	ecx,eax
						mov	edx,[esi].s__bufpm
						.if (edx==0)||([edx].s_used==0)
							and	[esi].waiting,32 xor -1
							invoke	LeaveCriticalSection,addr s_critical
							jmp	_r03c
						.endif
						add	ecx,[esi].s__idxpm
						.if ecx>=[edx].s_used
							mov	[edx].s_opcode,-1
							mov	edx,[edx].s_next
				;			call	_s_rem
							mov	[esi].s__bufpm,edx
							mov	[esi].s__idxpm,0
							mov	[esi].s__retry,0
						.elseif ecx>[edx].s_used
							int 3
						.else
							add	[esi].s__idxpm,eax
							mov	[esi].s__retry,0
						.endif
						invoke	LeaveCriticalSection,addr s_critical
					.endif
					and	[esi].waiting,32 xor -1
					.if [esi].pm_is_spam>2
						jmp	_r01c
					.endif
				.elseif ([edi].bfsize2!=eax)&&([edi].bfsize2!=0)
					inc	[esi].s__retry
					mov	ecx,[esi].s__retry
					.if (SendRetries!=0)&&(ecx>SendRetries)
						and	[esi].waiting,32 xor -1
						jmp	_r01c_
					.endif
					push	edi
					lea	edi,[esi].ovr_send.ovr
					xor	eax,eax
					stosd
					stosd
					stosd
					stosd
					stosd
					pop	edi
					mov	[esi].ovr_send.hMem,esi
					mov	eax,[esi].hSocket
					mov	[esi].ovr_send.hSocket,eax
					mov	[esi].ovr_send.opcode,OP_SEND
					mov	eax,wtransfered
					add	[esi].ovr_send.bfidx2,eax
					sub	[esi].ovr_send.bfsize2,eax
					mov	ecx,[esi].ovr_send.buffer2
					add	ecx,[esi].ovr_send.bfidx2
					invoke	WriteFile,[esi].hSocket,ecx,[esi].ovr_send.bfsize2,addr [esi].ovr_send.written,addr [esi].ovr_send
					.if eax==0
						invoke	WSAGetLastError
						.if eax!=ERROR_IO_PENDING
							and	[esi].waiting,32 xor -1
							mov	eax,OP_SEND
							jmp	_r01c
						.endif
					.endif
				.else
_scom_:					.if ([esi].last_op==2)
						jmp	_nopmdata
					.endif
					invoke	EnterCriticalSection,addr s_critical
					mov	edx,[esi].s__bufpm
					mov	eax,[edi].bfidx2
					add	[esi].s__idxpm,eax
					mov	ecx,wtransfered
					mov	eax,ecx
					add	ecx,[esi].s__idxpm
					.if ecx==0
						jmp	_scanidxpm
					.elseif ecx>=[edx].s_used
						call	_s_rem
						mov	[esi].s__bufpm,edx
_scanidxpm:					mov	eax,[esi].hSocket
						.while (edx!=s_lastpriv)&&(edx!=0)&&([edx].s_opcode!=0)
							.break .if (([edx].s_sendto==esi)&&([edx].s_opcode==4)&&(eax==[edx].s_socket))
							mov	ecx,[edx].s_sendto
							.break .if ecx==0
							assume	ecx:ptr usrstruc
							mov	ecx,[ecx].hSocket
							assume	ecx:nothing
							.if (ecx!=[edx].s_socket)||(ecx==0)||([edx].s_opcode==-1)
								call	_s_rem
							.else
								.break .if dword ptr[edx]==0
								mov	edx,[edx].s_next
							.endif
							mov	[esi].s__bufpm,edx
						.endw
						.if (edx!=0)&&([edx].s_used==0)
							mov	eax,[esi].hSocket
							.if (eax==[edx].s_socket)&&([esi].hSocket!=0)
								call	_s_rem
								invoke	LeaveCriticalSection,addr s_critical
								jmp	_r01c
							.endif
						.endif
						mov	[esi].s__idxpm,0
						mov	[esi].s__retry,0
						mov	s_lasterr,1
						invoke	LeaveCriticalSection,addr s_critical
						mov	edx,[esi].s__bufpm
						.if (edx!=s_lastpriv)&&([edx].s_opcode==4)
							jmp	_scom2
						.endif
						mov	wtransfered,0
						jmp	_nopmdata
					.elseif ecx>[edx].s_used
						int 3
					.else
						add	[esi].s__idxpm,eax
						mov	[esi].s__retry,0
						invoke	LeaveCriticalSection,addr s_critical
						mov	edx,[esi].s__bufpm
						jmp	_scom1
					.endif
					invoke	LeaveCriticalSection,addr s_critical
_scom:					.if ([esi].s__idx==0)||([esi].s__privcnt!=0)
						mov	edx,s_private
						.while (edx!=s_lastpriv)&&([edx].s_opcode!=0)
_scom2:							mov	eax,[esi].hSocket
							.if (esi==[edx].s_sendto)&&([edx].s_opcode==4)&&([edx].s_socket==eax)
								.if [esi].s__idxpm==0
									dec	[esi].s__privcnt
								.endif
_scom1:								push	edx
								call	s__pm_IOCP
								pop	edx
								jmp	_r03c
							.endif
							mov	edx,[edx].s_next
						.endw
					.endif
					mov	wtransfered,0
_nopmdata:
					mov	eax,s_private
					mov	[esi].s__bufpm,eax
					.if ([esi].loggedin==0)||([esi].waiting&2)
						jmp	_nodata
					.endif
					mov	[esi].last_op,0
					mov	edx,[esi].s__bufno
					mov	ecx,wtransfered
					mov	eax,ecx
					.if (ecx==0)&&([esi].s__idx==0)
						jmp	_nextblk
					.endif
					add	ecx,[esi].s__idx
					.if ecx>=[edx].s_used
						.if ([edx].s_opcode==1)||([edx].s_opcode==2)
							push	edx
							push	ecx
							invoke	EnterCriticalSection,addr s_critical
							pop	ecx
							.if ecx==[edx].s_used
								mov	[edx].s_pending,-2
								invoke	LeaveCriticalSection,addr s_critical
								pop	edx
							.else
								invoke	LeaveCriticalSection,addr s_critical
								pop	edx
								mov	eax,wtransfered
								jmp	_newdata
							.endif
						.endif
						mov	edx,[edx].s_next
						mov	[esi].s__bufno,edx
						mov	[esi].s__idx,0
						mov	[esi].s__retry,0
						jmp	_nextblk
					.elseif ecx>[edx].s_used
						int 3
					.else
_newdata:					add	[esi].s__idx,eax
						.if [edx].s_opcode==5
							call	s__trans
						.elseif [edx].s_opcode==6
							call	s__trans
						.elseif [edx].s_opcode==3
							call	s__ltrans
						.elseif ([edx].s_opcode==1)||([edx].s_opcode==2)
							jmp	_nextblk
						.endif
						jmp	_r03c
					.endif


_nextblk:				.if [esi]._web&1
						jmp	_nodata
					.endif
					.if [esi].myinfwait&4096
						.while (edx!=0)&&([edx].s_opcode!=0)
							.if ([edx].s_opcode==1)
								push	edx
								call	s__bcast_IOCP
								pop	edx
								.if [esi].last_op==2
									jmp	_r03c
								.endif
							.elseif ([edx].s_opcode==5)||(([edx].s_opcode==6)&&((!([esi+4].hubs&4))||(!(s_search.cmdflag&32))))
								.if ([edx].s_tcount!=0)||(esi==[edx].s_sendto)
									push	edx
									call	s__search_IOCP
									pop	edx
									.if [esi].last_op==2
										jmp	_r03c
									.endif
								.endif
							.elseif ([edx].s_opcode==3)
								push	edx
								call	s__lang_IOCP
								pop	edx
								.if [esi].last_op==2
									jmp	_r03c
								.endif
							.elseif ([edx].s_opcode==7)
								push	edx
								call	s__nickchange_IOCP
								pop	edx
								.if [esi].last_op==2
									jmp	_r03c
								.endif
							.endif
							mov	edx,[edx].s_next
							mov	[esi].s__bufno,edx
							mov	[esi].s__retry,0
							mov	[esi].s__idx,0
						.endw
					.else
						.while (edx!=0)&&([edx].s_opcode!=0)
							.if ([edx].s_opcode==1)
								push	edx
								call	s__bcast1_IOCP
								pop	edx
								.if [esi].last_op==2
									jmp	_r03c
								.endif
							.elseif ([edx].s_opcode==2)
								push	edx
								call	s__bcast_IOCP
								pop	edx
								.if [esi].last_op==2
									jmp	_r03c
								.endif
							.elseif ([edx].s_opcode==5)||(([edx].s_opcode==6)&&((!([esi+4].hubs&4))||(!(s_search.cmdflag&32))))
								.if ([edx].s_tcount!=0)||(esi==[edx].s_sendto)
									push	edx
									call	s__search_IOCP
									pop	edx
									.if [esi].last_op==2
										jmp	_r03c
									.endif
								.endif
							.elseif ([edx].s_opcode==3)
								push	edx
								call	s__lang_IOCP
								pop	edx
								.if [esi].last_op==2
									jmp	_r03c
								.endif
							.elseif ([edx].s_opcode==7)
								push	edx
								call	s__nickchange_IOCP
								pop	edx
								.if [esi].last_op==2
									jmp	_r03c
								.endif
							.endif
							mov	edx,[edx].s_next
							mov	[esi].s__bufno,edx
							mov	[esi].s__retry,0
							mov	[esi].s__idx,0
						.endw
					.endif

_nodata:				.if s_started==2
						.if [esi].waiting&128
							jmp	_send
						.endif
					.endif
					and	[esi].waiting,32 xor -1
					assume	edx:nothing
				.endif
			.elseif eax==OP_QOS
			;	mov	ebx,sizeof _qos
			;	invoke	WSAIoctl,[esi].hSocket,SIO_GET_QOS,0,0,addr [esi]._qos,ebx,addr [esi+40].buffer_tmp,addr [esi].ovr,0
			;	lea	eax,[esi]._qos
			.endif
		.endif
		mov	[esi].locked,0
		.else
			int 3
			invoke	Sleep,5
		.endif
		invoke	Sleep,0
		assume	edi:nothing
	.endw
workerThread	ENDP
assume	esi:nothing
endm
