;	Mode version 1.01 Copyright (C) 2006 Albu Cristian
;
;	This program is free software; you can redistribute it and/or modify
;	it under the terms of the GNU General Public License as published by
;	the Free Software Foundation.
;
;	This program is distributed in the hope that it will be useful,
;	but WITHOUT ANY WARRANTY; without even the implied warranty of
;	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;	GNU General Public License for more details.
;
;	You should have received a copy of the GNU General Public License
;	along with this program; if not, write to the Free Software
;	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

;	To compile download masm32 from http://www.masm32.com and install it on the root directory of one of your hard drives
;	Copy source files to the partition where is masm32 installed and run \masm32\bin\blddll mode
;	For more information send and e-mail to cristian.albu@gmail.com

.386
.model flat,stdcall
option casemap:none
include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib

include	plprocs.h

	dlgConfig	PROTO :DWORD,:DWORD,:DWORD,:DWORD
	modeProc	PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

modeInfo	struct
	nextmode	dd	?
	modeflag	db	?
	modecount	dd	?
	modeid		dd	?
	modescript	dd	?
	modeavail	dd	?
	modename	db	5 dup(?)
	modereset	db	5 dup(?)
	modename1	db	101 dup(?)
	modedesc	db	1025 dup(?)
modeInfo	ends

.data?
	saveflag	db	?
	modes		dd	?
	hInstance	dd	?
	_GetAddr	dd	?
	RegisterChatFilter dd	?
	UnregisterChatFilter dd	?
	ModeTransform	dd	?
	SetMode		dd	?
	GetLanguage	dd	?
	bread		dd	?
	seed1		dd	?
	seed2		dd	?
	datafile	db	8192 dup(?)
	buftmp		db	163840 dup(?)
	buftmp1		db	16384 dup(?)
	buftmp2		db	16384 dup(?)

.code
pluginName	db	'Chat modes',0
fn01		db	'RegisterChatFilter',0
fn02		db	'UnregisterChatFilter',0
fn03		db	'ModeTransform',0
fn04		db	'SetMode',0
fn05		db	'GetLanguage',0
hlpwin		db	'Plugin useage',0
hlptxt		db	'Plugin definitions can be Message definitions or Variabile definitions.'
		db	13,10,9,'Message definitions should start with "=" or with a 2-letter language identifier followed by "=".'
		db	13,10,9,9,'Example:	en=test %[255] %[text] %[hex 0D0A]'
		db	13,10,9,'Variabile definitions can be entered in this form: "%[",variabile_name,"]=" variariabile_definition.'
		db	13,10,9,'If more definitions for same variabile are found, one of them will be randomly selected.'
		db	13,10,9,9,'Example:	%[255]=test'
		db	13,10,13,10,9,'Reserved words that should not be used as variabiles:'
		db	13,10,9,9,'%[text]			- inserts original message'
		db	13,10,9,9,'%[hex hex_numbers]	- inserts ascii equivalent of hex_numbers character codes'
		db	13,10,9,9,'%[mode new_mode]	- inserts translation of original text using new_mode procedures'
		db	13,10,9,9,'%[find string]=value	- replaces a string in %[text] with value, this affects only %[text]',0


pl_procs
start	label	byte

DllEntry PROC dllInstance:DWORD,reason:DWORD,reserved1:DWORD
	.if reason==DLL_PROCESS_ATTACH
		push	dllInstance
		pop	hInstance
	.elseif reason==DLL_PROCESS_DETACH
	.elseif reason==DLL_THREAD_ATTACH
	.else
	.endif
	xor	eax,eax
	inc	eax
	ret
DllEntry Endp

InitPlugin	PROC	GetAddr:DWORD
	mov	saveflag,0
	mov	eax,GetAddr
	mov	_GetAddr,eax
	mov	modes,0
	push	offset fn01
	call	_GetAddr
	mov	RegisterChatFilter,eax
	push	offset fn02
	call	_GetAddr
	mov	UnregisterChatFilter,eax
	push	offset fn03
	call	_GetAddr
	mov	ModeTransform,eax
	push	offset fn04
	call	_GetAddr
	mov	SetMode,eax
	push	offset fn05
	call	_GetAddr
	mov	GetLanguage,eax
	call	getdatafile
	call	loadsettings
	lea	eax,pluginName
	ret
InitPlugin	ENDP

UnloadPlugin	PROC uses esi
	mov	esi,modes
	.while esi
		push	dword ptr[esi]
		assume	esi:ptr modeInfo
		push	esi
		.if (!([esi].modeflag&1))
			push	[esi].modeid
			call	UnregisterChatFilter
		.endif
		assume	esi:nothing
		call	GlobalFree
		pop	esi
	.endw
	mov	modes,0
	ret
UnloadPlugin	ENDP

SaveSettings	PROC
	assume	esi:ptr modeInfo
	.if saveflag==0
		ret
	.endif
	invoke	SetFileAttributes,addr datafile,0
	invoke	DeleteFile,addr datafile
	.if modes
		invoke	CreateFile,addr datafile,GENERIC_WRITE,0,0,CREATE_ALWAYS,0,0
		.if eax!=INVALID_HANDLE_VALUE
			push	eax
			mov	edi,eax
			mov	esi,modes
			.while esi
				push	edi
				lea	edi,buftmp+4
				mov	eax,[esi].modeavail
				stosd
				mov	al,[esi].modeflag
				stosb
				mov	eax,[esi].modecount
				stosd
				lea	edx,[esi].modename
				call	copystr
				lea	edx,[esi].modename1
				call	copystr
				lea	edx,[esi].modedesc
				call	copystr
				lea	edx,[esi].modereset
				call	copystr
				mov	edx,[esi].modescript
				call	copystr_
				mov	ecx,edi
				pop	edi
				sub	ecx,offset buftmp
				mov	dword ptr buftmp,ecx
				invoke	WriteFile,edi,addr buftmp,ecx,addr bread,0
				mov	esi,dword ptr[esi]
			.endw
			call	CloseHandle
		.endif
	.endif
	ret
SaveSettings	ENDP

loadsettings:
	invoke	CreateFile,addr datafile,GENERIC_READ,0,0,OPEN_EXISTING,0,0
	.if eax!=INVALID_HANDLE_VALUE
		push	eax
		mov	edi,eax
		lea	esi,modes
		.while 1
			mov	dword ptr buftmp,0
			invoke	ReadFile,edi,addr buftmp,4,addr bread,0
			.break .if (bread!=4)||(dword ptr buftmp<4)
			dec	dword ptr buftmp
			dec	dword ptr buftmp
			dec	dword ptr buftmp
			dec	dword ptr buftmp
			mov	ecx,dword ptr buftmp
			invoke	ReadFile,edi,addr buftmp+4,ecx,addr bread,0
			mov	ecx,dword ptr buftmp
			.break .if (ecx!=bread)||(eax==0)
			invoke	GlobalAlloc,GPTR,sizeof modeInfo
			mov	dword ptr[esi],eax
			mov	esi,eax
			mov	dword ptr[esi],0
			push	edi
			mov	eax,dword ptr buftmp+4
			mov	[esi].modeavail,eax
			mov	al,buftmp+8
			mov	[esi].modeflag,al
			mov	eax,dword ptr buftmp+9
			mov	[esi].modecount,eax
			lea	edi,[esi].modename
			lea	edx,buftmp+8+1+4
			call	copystr1
			lea	edi,[esi].modename1
			call	copystr1
			lea	edi,[esi].modedesc
			call	copystr1
			lea	edi,[esi].modereset
			call	copystr1
			push	edx
			mov	eax,[edx]
			lea	eax,[eax+10]
			invoke	GlobalAlloc,GPTR,eax
			mov	[esi].modescript,eax
			mov	edi,eax
			pop	edx
			call	copystr2
			.if (!([esi].modeflag&1))
				lea	eax,[esi].modedesc
				push	eax
				lea	eax,modeProc
				push	eax
				lea	eax,[esi].modename
				push	eax
				call	RegisterChatFilter
				mov	[esi].modeid,eax
			.endif
			pop	edi
		.endw
		call	CloseHandle
	.endif
	assume	esi:nothing
	ret

GetConfig	PROC	hParent:DWORD
	invoke	DialogBoxParam,hInstance,1000,hParent,offset dlgConfig,0
	ret
GetConfig	ENDP

_about	db	'Albu Cristian, 2006-2007',0
GetAboutText	PROC
	mov	eax,offset _about
	ret
GetAboutText	ENDP

dlgConfig	PROC	uses esi edi ebx hDlg:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
	.if uMsg==WM_INITDIALOG
		invoke	SendDlgItemMessage,hDlg,100,EM_LIMITTEXT,4,0
		invoke	SendDlgItemMessage,hDlg,101,EM_LIMITTEXT,100,0
		invoke	SendDlgItemMessage,hDlg,102,EM_LIMITTEXT,1024,0
		invoke	SendDlgItemMessage,hDlg,104,EM_LIMITTEXT,4,0
		invoke	SendDlgItemMessage,hDlg,110,EM_LIMITTEXT,65536*2,0
		invoke	SendDlgItemMessage,hDlg,110,EM_EXLIMITTEXT,0,65536*2
		mov	esi,modes
		.while esi
			assume	esi:ptr modeInfo
			invoke	SendDlgItemMessage,hDlg,200,LB_ADDSTRING,0,addr [esi].modename
			invoke	SendDlgItemMessage,hDlg,200,LB_SETITEMDATA,eax,esi
			mov	esi,[esi].nextmode
			assume	esi:nothing
		.endw
	.elseif uMsg==WM_COMMAND
		mov	eax,wParam
		mov	ebx,eax
		shr	ebx,16
		.if ax==2
			invoke	EndDialog,hDlg,0
		.elseif ax==1
			mov	saveflag,1
			invoke	GetDlgItemText,hDlg,100,addr buftmp,5
			mov	esi,offset modes
			mov	edx,[esi]
			mov	ax,100h
			xor	ecx,ecx
			.while edx
				assume	edx:ptr modeInfo
				lea	ebx,[edx].modename
				xor	ecx,ecx
				.while byte ptr[ebx+ecx]
					mov	al,[ebx+ecx]
					mov	ah,buftmp[ecx]
					or	ax,2020h
					.break .if al!=ah
					inc	ecx
				.endw
				.break .if (al==ah)&&(buftmp[ecx]==0)
				assume	edx:nothing
				mov	esi,edx
				mov	edx,[edx]
			.endw
			assume	esi:ptr modeInfo
			.if edx==0
				invoke	GlobalAlloc,GPTR,sizeof modeInfo
				mov	[esi].nextmode,eax
				mov	esi,eax
			.else
				mov	esi,edx
				push	[esi].modeid
				call	UnregisterChatFilter
				invoke	GlobalFree,[esi].modescript
			.endif
			lea	edx,buftmp
			lea	edi,[esi].modename
			call	copyedx
			mov	al,0
			stosb
			lea	edi,[esi].modename1
			invoke	GetDlgItemText,hDlg,101,edi,100
			lea	edi,[esi].modedesc
			invoke	GetDlgItemText,hDlg,102,edi,1024
			invoke	GetDlgItemInt,hDlg,103,0,0
			mov	[esi].modeavail,eax
			lea	edi,[esi].modereset
			invoke	GetDlgItemText,hDlg,104,edi,4
			invoke	SendDlgItemMessage,hDlg,110,WM_GETTEXTLENGTH,0,0
			push	eax
			lea	eax,[eax+10]
			invoke	GlobalAlloc,GPTR,eax
			mov	[esi].modescript,eax
			pop	ecx
			inc	ecx
			invoke	SendDlgItemMessage,hDlg,110,WM_GETTEXT,ecx,[esi].modescript
			mov	[esi].modeflag,0
			mov	ebx,[esi].modescript
			mov	dl,0
			xor	ecx,ecx
			.while byte ptr[ebx]!=0
				.while byte ptr[ebx]==32
					inc	ebx
				.endw
				.break .if byte ptr[ebx]==0
				.if (byte ptr[ebx]=='=')&&(dl==0)
					inc	ecx
				.elseif (byte ptr[ebx]==0dh)||(byte ptr[ebx]==0ah)
					mov	dl,0
				.else
					mov	dl,1
				.endif
				inc	ebx
			.endw
			.if ecx==0
				mov	dl,0
				mov	ebx,[esi].modescript
				.while byte ptr[ebx]!=0
					.if (byte ptr[ebx]==0dh)||(byte ptr[ebx]==0ah)
						mov	dl,0
					.else
						.if dl==0
							.if word ptr[ebx]=='[%'
								xor	eax,eax
								.while (byte ptr[ebx+eax]!=']')&&(byte ptr[ebx+eax]>31)
									inc	eax
								.endw
								.if byte ptr[ebx+eax]!=']'
									inc	ecx
								.endif
							.else
								inc	ecx
							.endif
						.endif
						mov	dl,1
					.endif
					inc	ebx
				.endw
			.endif
			mov	[esi].modecount,ecx
			mov	dl,0
			mov	ebx,[esi].modescript
			.while byte ptr[ebx]!=0
				.while byte ptr[ebx]==32
					inc	ebx
				.endw
				.break .if byte ptr[ebx]==0
				.if (byte ptr[ebx]==0dh)||(byte ptr[ebx]==0ah)
					mov	dl,0
				.else
					.if (dl==0)&&(word ptr[ebx]!='[%')&&(byte ptr[ebx]!='=')&&((byte ptr[ebx+1]=='=')||(byte ptr[ebx+2]=='='))
						or	[esi].modeflag,2
						.break
					.endif
					mov	dl,1
				.endif
				inc	ebx
			.endw
			invoke	IsDlgButtonChecked,hDlg,4
			.if eax==BST_CHECKED
				or	[esi].modeflag,1
			.endif
			xor	ecx,ecx
			.while 1
				push	ecx
				invoke	SendDlgItemMessage,hDlg,200,LB_GETITEMDATA,ecx,0
				pop	ecx
				.break .if (esi==eax)||(eax==LB_ERR)
				inc	ecx
			.endw
			.if esi!=eax
				lea	edx,[esi].modename
				invoke	SendDlgItemMessage,hDlg,200,LB_ADDSTRING,0,edx
				push	eax
				invoke	SendDlgItemMessage,hDlg,200,LB_SETITEMDATA,eax,esi
				pop	ecx
			.endif
			invoke	SendDlgItemMessage,hDlg,200,LB_SETCURSEL,ecx,0
			.if (!([esi].modeflag&1))
				lea	eax,[esi].modedesc
				push	eax
				lea	eax,modeProc
				push	eax
				lea	eax,[esi].modename
				push	eax
				call	RegisterChatFilter
				mov	[esi].modeid,eax
			.endif
			assume	esi:nothing
		.elseif ax==3
			mov	saveflag,1
			invoke	SendDlgItemMessage,hDlg,200,LB_GETCURSEL,0,0
			.if eax!=LB_ERR
				mov	edi,eax
				invoke	SendDlgItemMessage,hDlg,200,LB_GETITEMDATA,eax,0
				.if eax!=LB_ERR
					lea	edx,modes
					.while (dword ptr[edx]!=0)
						.if eax==[edx]
							mov	ecx,[eax]
							mov	[edx],ecx
							push	eax
							assume	eax:ptr modeInfo
							.if (!([eax].modeflag&1))
								push	dword ptr[eax].modeid
								call	UnregisterChatFilter
							.endif
							assume	eax:nothing
							call	GlobalFree
							.break
						.endif
						mov	edx,[edx]
					.endw
				.endif
				invoke	SendDlgItemMessage,hDlg,200,LB_DELETESTRING,edi,0
			.endif
		.elseif ax==5
			invoke	MessageBox,hDlg,addr hlptxt,addr hlpwin,MB_OK
		.elseif (ax==200)&&(bx==LBN_SELCHANGE)
			invoke	SendDlgItemMessage,hDlg,200,LB_GETCURSEL,0,0
			.if eax!=LB_ERR
				invoke	SendDlgItemMessage,hDlg,200,LB_GETITEMDATA,eax,0
				.if eax!=LB_ERR
					mov	esi,eax
					assume	esi:ptr modeInfo
					invoke	SetDlgItemText,hDlg,100,addr [esi].modename
					invoke	SetDlgItemText,hDlg,101,addr [esi].modename1
					invoke	SetDlgItemText,hDlg,102,addr [esi].modedesc
					invoke	SetDlgItemInt,hDlg,103,[esi].modeavail,0
					invoke	SetDlgItemText,hDlg,104,addr [esi].modereset
					invoke	SendDlgItemMessage,hDlg,110,WM_SETTEXT,0,[esi].modescript
					.if [esi].modeflag&1
						invoke	CheckDlgButton,hDlg,4,BST_CHECKED
					.else
						invoke	CheckDlgButton,hDlg,4,BST_UNCHECKED
					.endif
					assume	esi:nothing
				.endif
			.endif
		.endif
	.endif
	xor	eax,eax
	ret
dlgConfig	ENDP

modetmp	struct
	db	8 dup(?)
modetmp	ends

find_repl:
	push	ebx
	mov	ebx,edx
	push	edx
	push	ecx
	mov	ah,0
	mov	edx,ecx
	xor	ecx,ecx
	.while byte ptr[edx]!=0
		.if (byte ptr[edx]==13)||(byte ptr[edx]==10)
			mov	ah,0
		.else
			.if (ah==0)
				.while (byte ptr[edx]==32)||(byte ptr[edx]==9)
					inc	edx
				.endw
				.break .if (byte ptr[edx]==0)
				.if word ptr[edx]=='[%'
					mov	eax,[edx+2]
					or	eax,20202020h
					.if eax=='dnif'
						lea	edx,[edx+6]
						.if (byte ptr[edx]==32)||(byte ptr[edx]==9)
							inc	edx
						.endif
						push	ecx
						xor	ecx,ecx
						push	eax
						mov	ax,1
						.while (byte ptr[edx+ecx]!=']')&&(byte ptr[edx+ecx]!=13)&&(byte ptr[edx+ecx]!=10)&&(byte ptr[edx+ecx]!=0)
							mov	al,[ebx+ecx]
							mov	ah,[edx+ecx]
							or	ax,2020h
							.if al!=ah
								.break
							.endif
							inc	ecx
						.endw
						.if (al==ah)&&(byte ptr[edx+ecx]==']')
							inc	ecx
							.while byte ptr[edx+ecx]==32
								inc	ecx
							.endw
							.if byte ptr[edx+ecx]=='='
								inc	dword ptr[esp+4]
							.endif
						.endif
						pop	eax
						pop	ecx
					.endif
				.endif
			.endif
			mov	ah,1
		.endif
		inc	edx
	.endw
	.if ecx
		push	ecx
		call	random
		pop	ecx
		xor	edx,edx
		div	ecx
		mov	ecx,edx
		pop	edx
		pop	ebx
		push	ebx
		push	edx

		mov	ah,0
		inc	ecx
		.while (byte ptr[edx]!=0)&&(ecx!=0)
			.if (byte ptr[edx]==13)||(byte ptr[edx]==10)
				mov	ah,0
			.else
				.if (ah==0)
					.while (byte ptr[edx]==32)||(byte ptr[edx]==9)
						inc	edx
					.endw
					.break .if (byte ptr[edx]==0)
					.if word ptr[edx]=='[%'
						mov	eax,[edx+2]
						or	eax,20202020h
						.if eax=='dnif'
							lea	edx,[edx+6]
							.if (byte ptr[edx]==32)||(byte ptr[edx]==9)
								inc	edx
							.endif
							push	eax
							push	ecx
							mov	ax,1
							xor	ecx,ecx
							.while (byte ptr[edx+ecx]!=']')&&(byte ptr[edx+ecx]!=13)&&(byte ptr[edx+ecx]!=10)&&(byte ptr[edx+ecx]!=0)
								mov	al,[ebx+ecx]
								mov	ah,[edx+ecx]
								or	ax,2020h
								.if al!=ah
									.break
								.endif
								inc	ecx
							.endw
							.if (al==ah)&&(byte ptr[edx+ecx]==']')
								inc	ecx
								.while byte ptr[edx+ecx]==32
									inc	ecx
								.endw
								.if byte ptr[edx+ecx]=='='
									dec	dword ptr[esp]
								.endif
							.endif
							pop	ecx
							pop	eax
						.endif
					.endif
				.endif
				mov	ah,1
			.endif
			.if ecx
				inc	edx
			.endif
		.endw
		.if (ecx==0)
			.while (byte ptr[edx]!=']')&&(byte ptr[edx]!=13)&&(byte ptr[edx]!=10)&&(byte ptr[edx]!=0)
				inc	edx
				inc	ebx
				inc	dword ptr[esp+4]
			.endw
			.if byte ptr[edx]==']'
				inc	edx
			.endif
			.if byte ptr[edx]=='='
				inc	edx
			.endif
			.while (byte ptr[edx]!=13)&&(byte ptr[edx]!=10)&&(byte ptr[edx]!=0)
				mov	al,[edx]
				stosb
				inc	edx
			.endw
			xor	eax,eax
			inc	eax
		.else
			xor	eax,eax
		.endif

		xor	edx,edx
	.else
		xor	eax,eax
	.endif
	pop	ecx
	pop	edx
	pop	ebx
	ret

moderepl:
	.while (byte ptr[edx]!='|')&&(byte ptr[edx]!=0)
		call	find_repl
		.if eax==0
			mov	al,[edx]
			stosb
			inc	edx
		.endif
	.endw
	ret

modeProc	PROC uses esi edi ebx userId:DWORD,modeid:DWORD,srcstr:DWORD,deststr:DWORD,nummodes:DWORD
	local	language:DWORD
	local	tmpmode:modetmp
	local	tmpalloc:DWORD
	mov	edx,modes
	mov	tmpalloc,0
	assume	edx:ptr modeInfo
	mov	eax,modeid
	.while edx
		.break .if [edx].modeid==eax
		mov	edx,dword ptr[edx]
	.endw
	.if (edx==0)||((!([edx].modeflag&2))&&([edx].modecount==0))
_originalstr:	mov	esi,srcstr
		mov	edi,deststr
		.while (byte ptr[esi]!='|')
			movsb
		.endw
		movsb
		ret
	.endif
	.if [edx].modeavail
		mov	eax,nummodes
		inc	eax
		.if eax>=[edx].modeavail
			push	edx
			lea	eax,[edx].modereset
			push	eax
			push	userId
			call	SetMode
			pop	edx
		.endif
	.endif
	.if [edx].modeflag&2
		push	edx
		lea	eax,language
		push	eax
		push	userId
		call	GetLanguage
		pop	edx
		mov	ax,word ptr language
		or	ax,2020h
		mov	ebx,[edx].modescript
		xor	ecx,ecx
		push	edx
		mov	dl,0
		push	edx
		.while byte ptr[ebx]!=0
			.while byte ptr[ebx]==32
				inc	ebx
			.endw
			.break .if byte ptr[ebx]==0
			mov	dx,[ebx]
			or	dx,2020h
			.if (ax==dx)&&(byte ptr[ebx+2]=='=')&&(byte ptr[esp]==0)
				inc	ecx
			.elseif (byte ptr[ebx]==0dh)||(byte ptr[ebx]==0ah)
				mov	byte ptr[esp],0
			.else
				mov	byte ptr[esp],1
			.endif
			inc	ebx
		.endw
		pop	edx
		push	ecx
		call	random
		pop	ecx
		xor	edx,edx
		.if ecx==0
			pop	edx
			jmp	_normalmode
		.endif
		div	ecx
		mov	ecx,edx
		mov	ax,word ptr language
		or	ax,2020h
		pop	edx
		push	edx
		mov	ebx,[edx].modescript
		mov	dl,0
		push	edx
		.while byte ptr[ebx]!=0
			.while byte ptr[ebx]==32
				inc	ebx
			.endw
			.break .if byte ptr[ebx]==0
			mov	dx,[ebx]
			or	dx,2020h
			.if (ax==dx)&&(byte ptr[ebx+2]=='=')&&(byte ptr[esp]==0)
				.if ecx==0
					lea	ebx,[ebx+3]
					pop	edx
					pop	edx
					jmp	_nextstr
				.endif
				dec	ecx
			.elseif (byte ptr[ebx]==0dh)||(byte ptr[ebx]==0ah)
				mov	byte ptr[esp],0
			.else
				mov	byte ptr[esp],1
			.endif
			inc	ebx
		.endw
		pop	edx
		pop	edx
		jmp	_originalstr
	.else
_normalmode:	push	edx
		call	random
		pop	edx
		push	edx
		mov	ecx,[edx].modecount
		mov	ebx,[edx].modescript
		xor	edx,edx
		div	ecx
		mov	ecx,edx
		mov	dl,0
		push	ecx
		.while byte ptr[ebx]!=0
			.while byte ptr[ebx]==32
				inc	ebx
			.endw
			.break .if byte ptr[ebx]==0
			.if (byte ptr[ebx]=='=')&&(dl==0)
				.break .if ecx==0
				dec	ecx
			.elseif (byte ptr[ebx]==0dh)||(byte ptr[ebx]==0ah)
				mov	dl,0
			.else
				mov	dl,1
			.endif
			inc	ebx
		.endw
		pop	ecx
		pop	edx
_nextstr:	push	edx
		.if byte ptr[ebx]==0
			mov	ebx,[edx].modescript
			mov	dl,0
			.while byte ptr[ebx]!=0
				.while byte ptr[ebx]==32
					inc	ebx
				.endw
				.break .if byte ptr[ebx]==0
				.if (byte ptr[ebx]==0dh)||(byte ptr[ebx]==0ah)
					mov	dl,0
				.else
					.if (dl==0)
						.if word ptr[ebx]=='[%'
							xor	eax,eax
							.while (byte ptr[ebx+eax]!=']')&&(byte ptr[ebx+eax]>31)
								inc	eax
							.endw
							.if byte ptr[ebx+eax]!=']'
								.break .if ecx==0
								dec	ecx
							.endif
						.else
							.break .if ecx==0
							dec	ecx
						.endif
					.endif
					mov	dl,1
				.endif
				inc	ebx
			.endw
			.if (byte ptr [ebx]==0)
				pop	edx
				jmp	_originalstr
			.endif
		.endif
		.while byte ptr[ebx]==32
			inc	ebx
		.endw
		.if byte ptr[ebx]=='='
			inc	ebx
		.endif
		mov	edi,deststr
		.while (byte ptr[ebx]!=13)&&(byte ptr[ebx]!=10)&&(byte ptr[ebx]!=0)
			mov	al,[ebx]
			.if (al=='%')&&(byte ptr[ebx+1]=='[')
				mov	eax,[ebx+2]
				or	eax,20202020h
				.if (eax=='txet')&&(byte ptr[ebx+4+2]==']')
					pop	ecx
					push	ecx
					assume	ecx:ptr modeInfo
					mov	ecx,[ecx].modescript
					assume	ecx:nothing
					lea	ebx,[ebx+6]
					mov	edx,srcstr
					call	moderepl
				.elseif (eax==' xeh')
					lea	ebx,[ebx+6]
					.while (byte ptr[ebx]!=']')&&(byte ptr[ebx]!=13)&&(byte ptr[ebx]!=10)&&(byte ptr[ebx]!=0)
						.if byte ptr[ebx]!=32
							mov	al,[ebx]
							.if al>='a'
								sub	al,32
							.endif
							.if (al>='A')&&(al<='F')
								sub	al,7
							.endif
							and	al,0fh
							.if ((byte ptr[ebx+1]>='0')&&(byte ptr[ebx+1]<='9'))||((byte ptr[ebx+1]>='A')&&(byte ptr[ebx+1]<='F'))||((byte ptr[ebx+1]>='a')&&(byte ptr[ebx+1]<='f'))
								inc	ebx
								mov	ah,[ebx]
								.if ah>='a'
									sub	ah,32
								.endif
								.if (ah>='A')&&(ah<='F')
									sub	ah,7
								.endif
								and	ah,0fh
								shl	al,4
								or	al,ah
							.endif
							stosb
						.endif
						inc	ebx
					.endw
					dec	ebx
				.elseif (eax=='edom')&&(byte ptr[ebx+6]==32)
					lea	ebx,[ebx+7]
					push	edi
					lea	edi,tmpmode
					.while (byte ptr[ebx]==32)||(byte ptr[ebx]==9)
						inc	ebx
					.endw
					xor	ecx,ecx
					.while (byte ptr[ebx]!=']')&&(byte ptr[ebx]!=13)&&(byte ptr[ebx]!=10)&&(byte ptr[ebx]!=0)
						mov	al,[ebx]
						stosb
						inc	ebx
						inc	ecx
						.break .if ecx>=4
					.endw
					.while (byte ptr[ebx]!=']')&&(byte ptr[ebx]!=13)&&(byte ptr[ebx]!=10)&&(byte ptr[ebx]!=0)
						inc	ebx
					.endw
					mov	al,0
					stosb
					pop	edi
					push	ebx
					push	edi
					push	edi
					push	srcstr
					lea	eax,tmpmode
					push	eax
					push	userId
					call	ModeTransform
					pop	edi
					pop	ebx
					.while (byte ptr[edi]!='|')
						.if byte ptr[edi]==0
							mov	byte ptr[edi],'|'
							.break
						.endif
						inc	edi
					.endw
				.else
					pop	edx
					push	edx
					mov	edx,[edx].modescript
					mov	ah,0
					xor	ecx,ecx
					.while byte ptr[edx]!=0
						.if (byte ptr[edx]==13)||(byte ptr[edx]==10)
							mov	ah,0
						.else
							.if ah==0
								.while byte ptr[ebx]==32
									inc	ebx
								.endw
								.break .if byte ptr[ebx]==0
								.if word ptr[ebx]=='[%'
									push	ecx
									xor	ecx,ecx
									.while (byte ptr[ebx+ecx]!=']')&&(byte ptr[ebx+ecx]!=13)&&(byte ptr[ebx+ecx]!=10)&&(byte ptr[ebx+ecx]!=0)
										mov	al,[ebx+ecx]
										.break .if al!=byte ptr[edx+ecx]
										inc	ecx
									.endw
									.if (al==byte ptr[edx+ecx-1])&&(byte ptr[edx+ecx]==']')
										inc	ecx
										.while byte ptr[edx+ecx]==32
											inc	ecx
										.endw
										.if byte ptr[edx+ecx]=='='
											inc	dword ptr[esp]
										.endif
									.endif
									pop	ecx
								.endif
							.endif
							mov	ah,1
						.endif
						inc	edx
					.endw
					push	ecx
					call	random
					pop	ecx
					xor	edx,edx
					.if ecx
						div	ecx
						mov	ecx,edx
						pop	edx
						push	edx
						mov	edx,[edx].modescript
						mov	ah,0
						.while byte ptr[edx]!=0
							.if (byte ptr[edx]==13)||(byte ptr[edx]==10)
								mov	ah,0
							.else
								.if ah==0
									.while byte ptr[ebx]==32
										inc	ebx
									.endw
									.break .if byte ptr[ebx]==0
									.if word ptr[ebx]=='[%'
										push	ecx
										xor	ecx,ecx
										.while (byte ptr[ebx+ecx]!=']')&&(byte ptr[ebx+ecx]!=13)&&(byte ptr[ebx+ecx]!=10)&&(byte ptr[ebx+ecx]!=0)
											mov	al,[ebx+ecx]
											.break .if al!=byte ptr[edx+ecx]
											inc	ecx
										.endw
										.if (al==byte ptr[edx+ecx-1])&&(byte ptr[edx+ecx]==']')
											inc	ecx
											.while byte ptr[edx+ecx]==32
												inc	ecx
											.endw
											.if byte ptr[edx+ecx]=='='
												.if dword ptr[esp]==0
													pop	ecx
													.break
												.endif
												dec	dword ptr[esp]
											.endif
										.endif
										pop	ecx
									.endif
								.endif
								mov	ah,1
							.endif
							inc	edx
						.endw
						push	esi
						push	edi
						push	tmpalloc
						push	ebx
						push	edx
						invoke	GlobalAlloc,GPTR,16384
						mov	tmpalloc,eax
						mov	edi,eax
						pop	edx
						.if word ptr[edx]=='[%'
							.while (byte ptr[edx]!=']')&&(byte ptr[edx]!=13)&&(byte ptr[edx]!=10)&&(byte ptr[edx]!=0)
								inc	edx
							.endw
							.if byte ptr[edx]==']'
								.while (byte ptr[edx]!='=')&&(byte ptr[edx]!=13)&&(byte ptr[edx]!=10)&&(byte ptr[edx]!=0)
									inc	edx
								.endw
								.if byte ptr[edx]=='='
									.while (byte ptr[edx]!=13)&&(byte ptr[edx]!=10)&&(byte ptr[edx]!=0)
										mov	al,[edx]
										stosb
										inc	edx
									.endw
								.endif
							.endif
						.endif
						pop	ebx
						.if word ptr[ebx]=='[%'
							.while (byte ptr[ebx]!=']')&&(byte ptr[ebx]!=13)&&(byte ptr[ebx]!=10)&&(byte ptr[ebx]!=0)
								inc	ebx
							.endw
							.if byte ptr[ebx]==']'
								inc	ebx
								.while (byte ptr[ebx]!=13)&&(byte ptr[ebx]!=10)&&(byte ptr[ebx]!=0)
									mov	al,[ebx]
									stosb
									inc	ebx
								.endw
							.endif
						.endif
						mov	ax,'|'
						stosw
						pop	eax
						.if eax
							invoke	GlobalFree,eax
						.endif
						pop	edi
						pop	esi
						mov	ebx,tmpalloc
					.endif
				.endif
			.else
				stosb
			.endif
			inc	ebx
		.endw
		mov	al,'|'
		stosb
		pop	edx
	.endif
	.if tmpalloc
		invoke	GlobalFree,tmpalloc
	.endif
	ret
	assume	edx:nothing
modeProc	ENDP

End DllEntry
